-----------------------------------------------
---- Raeli's Spell Announcer Priest Module ----
-----------------------------------------------
local RSA = LibStub("AceAddon-3.0"):GetAddon("RSA")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")
local RSA_Priest = RSA:NewModule("Priest")


function RSA_Priest:OnInitialize()
	if RSA.db.profile.General.Class == "PRIEST" then
		RSA_Priest:SetEnabledState(true)
	else
		RSA_Priest:SetEnabledState(false)
	end
end -- End OnInitialize

function RSA_Priest:OnEnable()
local pName = UnitName("player")
local function Priest_Spells(_, _, _, event, _, source, _, _, dest, _, spellID, spellName, _, missType)
	local petName = UnitName("pet")
	if source == pName or source == petName then
		if (event == "SPELL_CAST_SUCCESS" and RSA.db.profile.Modules.Reminders_Loaded == true) then -- Reminder Refreshed
			local ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
			if spellName == ReminderSpell and (dest == pName or dest == nil) then
				RSA_Reminder:SetScript("OnUpdate", nil)				
				if RSA.db.profile.Reminders.RemindChannels.Chat == true then
					RSA_Print_Self(ReminderSpell .. L[" Refreshed!"])
				end
				if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
					RSA_Print_Self_RW(ReminderSpell .. L[" Refreshed!"])
				end
			end			
		end -- BUFF REMINDER

		if event == "SPELL_AURA_APPLIED" then		
			if spellID == 9484 then -- SHACKLE UNDEAD
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.ShackleUndead.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.ShackleUndead.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHACKLE UNDEAD					
			if spellID == 7001 then -- LIGHTWELL RENEW
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.LightwellRenew.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.LightwellRenew.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.LightwellRenew.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.LightwellRenew.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.LightwellRenew.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.LightwellRenew.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.LightwellRenew.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.LightwellRenew.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.LightwellRenew.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- LIGHTWELL RENEW

		end -- IF EVENT IS SPELL_AURA_APPLIED


		if event == "SPELL_CAST_SUCCESS" then
			if spellID == 73325 then -- LEAP OF FAITH
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.LeapOfFaith.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.LeapOfFaith.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.LeapOfFaith.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.LeapOfFaith.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.LeapOfFaith.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.LeapOfFaith.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.LeapOfFaith.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.LeapOfFaith.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- LEAP OF FAITH
			if spellID == 64843 then -- DIVINE HYMN
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.DivineHymn.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.DivineHymn.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.DivineHymn.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.DivineHymn.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE HYMN
			if spellID == 64901 then -- HYMN OF HOPE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.HymnOfHope.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.HymnOfHope.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- HYMN OF HOPE	
			if spellID == 6346 then -- FEAR WARD
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.FearWard.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.FearWard.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.FearWard.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.FearWard.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.FearWard.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.FearWard.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.FearWard.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- FEAR WARD
			if spellID == 1706 then -- LEVITATE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.Levitate.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.Levitate.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.Levitate.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.Levitate.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.Levitate.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.Levitate.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.Levitate.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- LEVITATE			
			if spellID == 47788 then -- GUARDIAN SPIRIT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- GUARDIAN SPIRIT			
			if spellID == 33206 then -- PAIN SUPPRESSION
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.PainSuppression.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PainSuppression.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PainSuppression.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PainSuppression.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- PAIN SUPPRESSION			
			if spellID == 10060 then -- POWER INFUSION
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.PowerInfusion.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PowerInfusion.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- POWER INFUSION			
			if spellID == 62618 then -- POWER WORD: BARRIER
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.PowerWordBarrier.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PowerWordBarrier.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.PowerWordBarrier.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PowerWordBarrier.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PowerWordBarrier.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PowerWordBarrier.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PowerWordBarrier.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- POWER WORD: BARRIER

		end -- IF EVENT IS SPELL_CAST_SUCCESS


		if event == "SPELL_SUMMON" then		
			if spellID == 724 then -- LIGHTWELL
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Priest.Spells.Lightwell.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.Lightwell.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.Lightwell.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.Lightwell.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.Lightwell.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.Lightwell.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.Lightwell.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.Lightwell.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- LIGHTWELL	

		end -- IF EVENT IS SPELL_SUMMON


		if event == "SPELL_AURA_REMOVED" then
			if spellID == 64843 then -- DIVINE HYMN
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Priest.Spells.DivineHymn.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.DivineHymn.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.DivineHymn.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.DivineHymn.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.DivineHymn.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE HYMN
			if spellID == 64901 then -- HYMN OF HOPE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.HymnOfHope.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.HymnOfHope.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- HYMN OF HOPE			
			if spellID == 6346 then -- FEAR WARD
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.FearWard.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.FearWard.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.FearWard.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.FearWard.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.FearWard.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.FearWard.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.FearWard.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- FEAR WARD
			if spellID == 1706 then -- LEVITATE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.Levitate.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.Levitate.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.Levitate.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.Levitate.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.Levitate.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.Levitate.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.Levitate.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- LEVITATE				
			if spellID == 9484 then -- SHACKLE UNDEAD
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.ShackleUndead.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.ShackleUndead.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHACKLE UNDEAD				
			if spellID == 47788 then -- GUARDIAN SPIRIT
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- GUARDIAN SPIRIT
			if spellID == 33206 then -- PAIN SUPPRESSION
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.PainSuppression.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.PainSuppression.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PainSuppression.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PainSuppression.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PainSuppression.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- PAIN SUPPRESSION			
			if spellID == 10060 then -- POWER INFUSION
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.PowerInfusion.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PowerInfusion.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- POWER INFUSION

		end -- IF EVENT IS SPELL_AURA_REMOVED


		if event == "SPELL_DISPEL" then	
			if spellID == 527 then -- DISPEL MAGIC
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
				if RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.DispelMagic.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.DispelMagic.Whisper == true and dest ~= pName and dest ~= pName and UnitIsPlayer(dest) and UnitIsFriend(pName, dest) then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"], ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
					end
					if RSA.db.profile.Priest.Spells.DispelMagic.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.DispelMagic.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.DispelMagic.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.DispelMagic.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.DispelMagic.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.DispelMagic.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- DISPEL MAGIC			
			if spellID == 528 then -- CURE DISEASE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[AURA]"] = extraspellinfo, ["[AURALINK]"] = extraspellinfolink,}
				if RSA.db.profile.Priest.Spells.CureDisease.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.CureDisease.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.CureDisease.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.CureDisease.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.CureDisease.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.CureDisease.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.CureDisease.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.CureDisease.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.CureDisease.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.CureDisease.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.CureDisease.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.CureDisease.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.CureDisease.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.CureDisease.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.CureDisease.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- CURE DISEASE

		end -- IF EVENT IS SPELL_DISPEL		

	else

		if event == "SPELL_AURA_REMOVED" then
				if spellID == 81781 then -- POWER WORD: BARRIER
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo,}
				if RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.PowerWordBarrier.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PowerWordBarrier.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.PowerWordBarrier.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PowerWordBarrier.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PowerWordBarrier.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PowerWordBarrier.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PowerWordBarrier.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PowerWordBarrier.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- POWER WORD: BARRIER
			
		end -- END IF SPELL_AURA_REMOVED
	end -- IF SOURCE IS PLAYER		
end -- END ENTIRELY
RSA_CombatLogMonitor:SetScript("OnEvent", Priest_Spells)

------------------------------
---- Resurrection Monitor ----
------------------------------
local function Priest_Resurrection(self, event, unitID, spell, _, dest)
			if spell == "Resurrection" then -- RESURRECTION
				if (dest == "Unknown" or dest == nil) then
					dest = string.gsub(GameTooltipTextLeft1:GetText(), L["Corpse of "], "")
				end
				spellinfo = GetSpellInfo(spell) spelllinkinfo = GetSpellLink(spell)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Priest.Spells.Resurrection.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.Resurrection.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.Resurrection.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = L["You"],}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.Resurrection.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Priest.Spells.Resurrection.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.Resurrection.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.Resurrection.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.Resurrection.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.Resurrection.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.Resurrection.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- RESURRECTION
end -- END FUNCTION
RSA_ResMon:SetScript("OnEvent", Priest_Resurrection)
end -- END ON ENABLED

function RSA_Priest:OnDisable()
RSA_CombatLogMonitor:SetScript("OnEvent", nil)
RSA_ResMon:SetScript("OnEvent", nil)
end